#!/bin/bash

suffix=""
prefix=""
number=0

if ! options=$(getopt -o p:s:n: -l prefix:,suffix:,number: -- "$@"); then
    exit 1
fi

set -- $options

while [ $# -gt 1 ]; do
case $1 in
	-s|--suffix) suffix="$2"; shift;;
	-p|--prefix) prefix="$2"; shift;;
	-n|--number) number="$2"; shift;;
	--) shift; break;;
   	*) break;;
esac
shift
done

mask=$1

#----------------------------------

function trimq() {
	local __resultvar=$2
	local res=$1
	if [[ ${res:0:1} == "'" ]]; then
		let __ln=${#res}-2
		res=${res:1:__ln}
	fi
	eval $__resultvar="'$res'"
}

trimq $prefix prefix
trimq $suffix suffix
trimq $number number
trimq $mask mask

#----------------------------------

oldifs="$IFS"
IFS=$(echo -ne "\n\b")

let i=0
for fn in $(find . -maxdepth 1 -name "$mask"); do
	if [[ $fn == "." ]]; then continue; fi;
	if [[ $(stat -c "%F" $fn) == "directory" ]]; then continue; fi;
	let cnum=i+number
	fn=${fn:2}
	ext=$(expr "$fn" : '.*\(\..*\)')
	newName=$prefix$cnum$suffix$ext
	if [[ $fn != $newName ]]; then mv $fn $newName; fi
	let i=i+1
done

IFS=$oldifs
