#!/bin/bash

devs=$(ip addr show | grep -Pe 'state UP' | grep -Poe ':.*:' | grep -Poe '[^: ]*')

let netCount=0
for i in $devs; do
	lnws[netCount]=$(ip -4 addr show dev $i | grep -Poe 'inet \d+\.\d+\.\d+\.\d+/\d+\b' | grep -Poe '[\W\d]*' | grep -Poe '\S*')
	let netCount=netCount+1
done

function numOfComps() {
	local __resultvar=$2
	local net=$1
	local inx=`expr index "$net" /`
	local mask=${net:inx}
	local nc=$(echo "2^(32-$mask)-1" | bc)
	eval $__resultvar="'$nc'"
}

function netToNum() {
	local __resultvar=$2
	local net=$1
	local i
	local n
	local inx
	for i in $(seq 0 3); do
		if (( i == 3 )); then
			inx=`expr index "$net" /`
		else
			inx=`expr index "$net" .`
		fi
		let inx=inx-1
		n[$i]=${net:0:inx}
		let inx=inx+1
		net=${net:inx}
	done
	local netnum=$(echo "${n[0]}*2^24+${n[1]}*2^16+${n[2]}*2^8+${n[3]}" | bc)
	local mask=$(echo "4294967295-2^(32-$net)+1" | bc)
	local rs=$(perl -e "print ($netnum & $mask)")
	eval $__resultvar="'$rs'"
}

function numToNet() {
	local __resultvar=$2
	local net=$1
	local n1=$(echo "$net%256" | bc);
	net=$(echo "$net/256" | bc);
	local n2=$(echo "$net%256" | bc);
	net=$(echo "$net/256" | bc);
	local n3=$(echo "$net%256" | bc);
	net=$(echo "$net/256" | bc);
	local n4=$(echo "$net%256" | bc);
	eval $__resultvar="'$n4.$n3.$n2.$n1'"
}

for net in ${lnws[*]}; do
	numOfComps $net num
	netToNum $net subnet
	echo "Subnet: $net ----------------------"
	for i in $(seq 1 $num); do
		let cip=subnet+i
		numToNet $cip ipaddr
		ping -c 1 -W 1 $ipaddr > /dev/null 2> /dev/null
		if (( $? == 0 )); then
			echo "$ipaddr"	
		fi
	done
done
