#!/bin/bash

let needRequest=1
mask=""

function printhelp() {
	echo "Smart file remover"
	echo "Usage: ./task6 [-v] [-h||--help] <mask>"
	echo "-v -- remove all"
	echo "-h || --help -- show help"
	echo "<mask> -- file mask"
	return
}

if [[ (( $# == 0 )) || (($# > 2)) ]]; then
	echo "Wrong number of parameters. Usage: ./task6 [-v] [-h||--help] <mask>"
	exit
fi

if (( $# == 1 )); then
	if [[ $1 == "-v" ]]; then
		echo "Wrong parameters. Usage: ./task6 [-v] [-h||--help] <mask>"
		exit
	fi
	if [[ $1 == "-h" || $1 == "--help" ]]; then
		printhelp
		exit
	fi
	
	mask=$1
fi

if (( $# == 2 )); then
	if [[ $1 == "-h" || $1 == "--help" || $2 == "-h" || $2 == "--help" ]]; then
		printhelp
		exit
	fi

	if [[ $1 == "-v" ]]; then
		let needRequest=0
		mask=$2
	fi

	if [[ $2 == "-v" ]]; then
		let needRequest=0
		mask=$1
	fi
fi

#for fn in $(ls $mask); do
ls $mask | while read fn; do
	if((needRequest == 1)); then
		while((1)); do
			printf "Remove file $fn? [y/n]: "
			read answ
			if [[ $answ == "y" ]]; then
				rm -f $fn
				break
			fi
			if [[ $answ == "n" ]]; then
				break
			fi
		done
	else
		rm -f $fn
	fi
done
