#!/bin/bash

declare -i height=36 width=135

bright0="\E[2;32m"
bright1="\E[1;32m"
base_symb[1]="\U308c"
base_symb[2]="\U30aa"
base_symb[3]="\U30bf"
base_symb[4]="\U30c1"
base_symb[5]="\U30c6"
base_symb[6]="\U30e2"
base_symb[7]="\U3055"
base_symb[8]="\U3061"

draw_symb(){
	let "r = $RANDOM % 8"
	if [[ "$r" -eq 1 ]]; then
		echo -ne "\E[${2};${3}H $no_color"
	else
		let "number = $RANDOM % 10"
		if [[ "${5}" -eq 0 ]]; then
			case "${1}" in
			0 ) echo -ne "\E[${2};${3}H $bright0 ${base_symb[${4}]}";;
			1 ) echo -ne "\E[${2};${3}H $bright1 ${base_symb[${4}]}";;
			esac
		else
			case "${1}" in
			0 ) echo -ne "\E[${2};${3}H $bright0 $number";;
			1 ) echo -ne "\E[${2};${3}H $bright1 $number";;
			esac
		fi
	fi
}

columns=8
col_size=height

draw_matrix(){
	for ((i=1; i<columns; i++)); do
		let "col[i] = $RANDOM % width"
		let "lines[i] = $RANDOM % col_size"
		let "color[i] = $RANDOM % 2"
	done	
	for ((k=1; k<col_size; k++)); do
    		for ((i=1; i<columns; i++)); do
			let "a = 1 + $RANDOM % 9"
			let "is_number = $RANDOM % 2"
			if [ $k -lt "${lines[$i]}" ]; then
    			draw_symb ${color[$i]} $k ${col[$i]} $a $is_number
			fi
		done
	done
}

while [ 1 -eq 1 ]; do
	clear
	for ((j=1; j<20; j++)); do
		draw_matrix
	done
done
